package javax.swing;

import java.awt.Container;
import sun.awt.AppContext;

public abstract class LayoutStyle
{
    public static void setInstance(LayoutStyle value) {
        synchronized (LayoutStyle.class) {
            if (value == null) {
                AppContext.getAppContext().remove(LayoutStyle.class);
            }
            else {
                AppContext.getAppContext().put(LayoutStyle.class, value);
            }
        }
    }
    
    public static LayoutStyle getInstance() {
        LayoutStyle layoutStyle;
        synchronized (LayoutStyle.class) {
            layoutStyle = (LayoutStyle)AppContext.getAppContext().get(LayoutStyle.class);
        }
        if (layoutStyle == null) {
            return UIManager.getLookAndFeel().getLayoutStyle();
        }
        return layoutStyle;
    }
    
    public LayoutStyle() {
    }
    
    public abstract int getPreferredGap(JComponent p0, JComponent p1, LayoutStyle.ComponentPlacement p2, int p3, Container p4);
    
    public abstract int getContainerGap(JComponent p0, int p1, Container p2);
    
    public enum ComponentPlacement
    {
        RELATED, 
        UNRELATED, 
        INDENT;
    }
}
